import lejos.nxt.*;
import lejos.navigation.*;

public class NavigatingCar 
{
    static final float wheelsize = 6.9f;
    static final float trackwidth = 17.68f; //18f; (too long) //17.5f;(too short)
    
    public static void main(String [] args)
    {
	TachoNavigator tnav = new TachoNavigator(wheelsize, trackwidth, Motor.A, Motor.C);

	CompassSensor compass = new CompassSensor(SensorPort.S1);
	compass.resetCartesianZero();
	CompassNavigator cnav = new CompassNavigator(compass, wheelsize, trackwidth,
						     Motor.A, Motor.C, false);

	cnav.calibrateCompass();
	
        LCD.drawString("Navigating Car",0,0);
        LCD.refresh();
    	
	//	nav.goTo(200, 0); // Wheel size calibration

	//	for(int i = 0; i < 8; i++) nav.rotate(180, false); // Track width calibration.

	/*
	nav.goTo(  50,   0);
	nav.goTo(   0, 100);
	nav.goTo(-100,   0);
	nav.goTo(   0,-100);
	nav.goTo(   0,   0);
	*/

	// 0
	cnav.rotateTo(0);
	tnav.travel(50 / 2);

	// 1
	cnav.rotateTo(90 + 26.566f);
	tnav.travel((float)Math.sqrt(50*50 + 100*100) / 2);

	// 2
	cnav.rotateTo(180 + 45);
	tnav.travel((float)Math.sqrt(100*100 + 100*100) / 2);

	// 3
	cnav.rotateTo(360 - 45);
	tnav.travel((float)Math.sqrt(100*100 + 100*100) / 2);

	// 4
	cnav.rotateTo(90);
	tnav.travel(100 / 2);
	

    	LCD.clear();
        LCD.drawString("Program stopped",0,0);
        LCD.refresh();
    }    
}
